



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Chapter 6 - How to Play Music and Sound Effect</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Chapter 6 - How to Play Music and Sound Effect</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 20:25:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>In this chapter, we would add background music to the game and play sound effect when the hero fires bullets.</p>
<p>Because there&rsquo;s so few codes to add that we could say a little more about audio engine here. Cocos2d-x has wrapped SimpleAudioEngine to cross platforms. In our game, we are able to play music and sound effect using only one line of codes. It is so convenient. Of course, audio formats supported in different platform are different, about this issue, you could refer to <a href="http://www.cocos2d-x.org/projects/cocos2d-x/wiki/Audio_formats_supported_by_CocosDenshion_on_different_platforms" rel="external nofollow noreferrer">http://www.cocos2d-x.org/projects/cocos2d-x/wiki/Audio_formats_supported_by_CocosDenshion_on_different_platforms</a>.</p>
<p>In fact, cocos2d-iphone includes the cocosDenshion library, and the library offers three layers of interfaces: CDSoundEngine-&gt;CDAudioManager-&gt;SimpleAudioEngine, but its realization totally relies on OpenAL. About OpenAL, it is not a standard of Khronos Group, it is an open source of Creative, which could be realize by software and hardware. So far, OpenAL is hardware realized only by Apple&rsquo;s products, so in other platforms, we couldn&rsquo;t provide supports for the lower layers of cocosDenshion, but we support the top layer which is used most commonly by the developers.</p>
<p>Now let&rsquo;s get right to the issues. <br />First, copy the sound files background-music-aac.wav and pew-pew-lei.wav to the Resource directory. We use wav here because wav is supported in all platforms and these two files have been included in the Cocos2dSimpleGame project, you could download them from the bottom of this page.    <br />Then include SimpleaudioEngine.h in HelloWorldScene.cpp.</p>
<pre class="prettyprint linenums">1// cpp with cocos2d-x<br />
2#include "SimpleAudioEngine.h"    </pre>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>
<p>Add the background music in init().</p>
<pre class="prettyprint linenums">1// cpp with cocos2d-x<br />
2CocosDenshion::SimpleAudioEngine::sharedEngine()-&gt;playBackgroundMusic(<br />
3"background-music-aac.wav", true);    </pre>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>
<p>And play the sound effect in ccTouchesEnded() when the bullet is fired.</p>
<pre class="prettyprint linenums">1// cpp with cocos2d-x<br />
2CocosDenshion::SimpleAudioEngine::sharedEngine()-&gt;playEffect(<br />
3"pew-pew-lei.wav");    </pre>
<p><!--<br />
.csharpcode, .csharpcode pre<br />
{<br />
	font-size: small;<br />
	color: black;<br />
	font-family: consolas, "Courier New", courier, monospace;<br />
	background-color: #ffffff;<br />
	/*white-space: pre;*/<br />
}<br />
.csharpcode pre { margin: 0em; }<br />
.csharpcode .rem { color: #008000; }<br />
.csharpcode .kwrd { color: #0000ff; }<br />
.csharpcode .str { color: #006080; }<br />
.csharpcode .op { color: #0000c0; }<br />
.csharpcode .preproc { color: #cc6633; }<br />
.csharpcode .asp { background-color: #ffff00; }<br />
.csharpcode .html { color: #800000; }<br />
.csharpcode .attr { color: #ff0000; }<br />
.csharpcode .alt<br />
{<br />
	background-color: #f4f4f4;<br />
	width: 100%;<br />
	margin: 0em;<br />
}<br />
.csharpcode .lnum { color: #606060; }<br />
--></p>
<p>Ok, the audio addition is completed now.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxd7gz9.html">Web 分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy4og2q.html">Docker的容器创建以及基本命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g4xnl9.html">如何防止sql注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pvxy79.html">MongoDB与衍生版的TokuMX对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73lkg8.html">eclipse-搭建maven的war项目集合spring注解方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6d7gq.html">JQuery 定时器 &lpar;Jquery Timer 插件&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93mmgr8.html">Syslog</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zmzyx9.html">android wheelview 滚轮控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0zplwq.html">JAVA判断当前时间是上午am还是下午pm</a>
		</li>
						<li><a href="https://www.batexi.com/a/90velnn8.html">十四、Android学习笔记&lowbar;Android回调函数触发的几种方式 广播 静态对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v03om8.html">QQ登录接口（第三方登录接口）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zy6x8.html">CodeForces 591B</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kmgn59.html">Windows Phone 9再见了&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdderz9.html">让struts2和servlet共存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1r4voq.html">&lbrack;Open Source&rsqb; 负载均衡之Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdgvk9.html">Java之面向对象例子（三） 多态，重写，重载，equals&lpar;&rpar;方法和toString&lpar;&rpar;方法的重写</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgdeo8.html">CSS 学习笔记 - Flex 布局</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge0ljl8.html">Problem &colon; 1002 &lpar; A &plus; B Problem II &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j11o5w9.html">go基础系列：结构struct</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12ppeq.html">Java &mdash;&mdash; 对象</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mwvgjq.html">hdu 4739</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdeyxz8.html">【BZOJ 1010】 &lbrack;HNOI2008&rsqb;玩具装箱toy （斜率优化）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wnl5oq.html">ANDROID&lowbar;MARS学习笔记&lowbar;S05&lowbar;003&lowbar;传感器采样率及属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y2vx5q.html">Migrating from IntelliJ Projects</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xv47v8.html">VS发布&comma;TFS邮件设置截图</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjy0ez9.html">开源cms</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z12dzn9.html">HDU-                     Who Gets the Most Candies&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vnozo8.html">HDOJ&sol;HDU 1022 Train Problem I&lpar;模拟栈&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xl07w9.html">&period;Net 调式案例&mdash;实验4 高CPU（High CPU）回顾</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zomv49.html">Android游戏与应用开发最佳学习路线图</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
